%global _version    1.0.0
%global gem_name    deep_merge
%global _name       rubygem-%{gem_name}
%if 0%{?rhel} == 5
%global gem_dir     %(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%define gem_instdir %{gem_dir}/gems/%{gem_name}-%{_version}
%endif

%define gem         %{_bindir}/gem

Name:               %{_name}
Version:            %{_version}
Release:            2%{?dist}
Vendor:             %{?_host_vendor}
Summary:            Recursively merge hashes

Group:              Development/Languages
License:            MIT
URL:                http://rubygems.org/gems/%{gem_name}/versions/%{_version}
Source0:            http://rubygems.org/downloads/%{gem_name}-%{_version}.gem

BuildRoot:          %{_tmppath}/%{name}-%{version}-%{release}-%(id -un)
BuildArch:          noarch

%if 0%{?rhel} == 5
BuildRequires:      ruby
BuildRequires:      rubygems
Requires:           ruby(abi) >= 1.8
%else
BuildRequires:      rubygems-devel
Requires:           ruby
%endif

Requires:           rubygems
%if 0%{?rhel} == 5
Provides:           rubygem(%{gem_name}) = %{_version}
%endif
# This is the start of the new naming scheme so it obsoletes the old one
Provides:           rubygem-deep-merge = %{version}-%{release}
Obsoletes:          rubygem-deep-merge < 1.0.0-2%{dist}

%description
Deep Merge is a simple set of utility function for Hash. It permits
you to merge elements inside a hash together recursively. The manner
by which it does this is somewhat arbitrary (since there is no defining
standard for this) but it should end up being pretty intuitive and do what
you expect.

%prep

%build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{gem_dir}
%{gem} install --local --install-dir $RPM_BUILD_ROOT%{gem_dir} \
        --force --rdoc %{SOURCE0}

# Remove backup files
find $RPM_BUILD_ROOT%{gem_instdir} -type f -name '*~' -delete

# Delete zero-length files
find $RPM_BUILD_ROOT%{gem_instdir} -type f -size 0c -exec rm -rvf {} \;

# Fix anything executable that does not have a shebang
for file in `find $RPM_BUILD_ROOT%{gem_instdir} -type f -perm /a+x`; do
  [ -z "`head -n 1 $file | grep \"^#!/\"`" ] && chmod -v 644 $file
done

# Find files with a shebang that do not have executable permissions
for file in `find $RPM_BUILD_ROOT%{gem_instdir} -type f ! -perm /a+x -name "*.rb"`; do
  [ ! -z "`head -n 1 $file | grep \"^#!/\"`" ] && chmod -v 755 $file
done

# Find files that have non-standard-executable-perm
find $RPM_BUILD_ROOT%{gem_instdir} -type f -perm /g+wx -exec chmod -v g-w {} \;

# Find files that are not readable
find $RPM_BUILD_ROOT%{gem_instdir} -type f ! -perm /go+r -exec chmod -v go+r {} \;

# Fix shebang ling of scripts
for file in `find $RPM_BUILD_ROOT%{_prefix} -type f`; do
  sed -i -e '1s,^#!.*ruby$,#!%{_bindir}/ruby,' $file
done

rm -rf $RPM_BUILD_ROOT/%{gem_instdir}/test
rm -rf $RPM_BUILD_ROOT/%{gem_instdir}/Rakefile

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{gem_instdir}/lib
%doc %{gem_instdir}/README
%doc %{gem_instdir}/CHANGELOG
%doc %{gem_instdir}/VERSION
%doc %{gem_dir}/doc
%{gem_dir}/cache/%{gem_name}-%{version}.gem
%{gem_dir}/specifications/%{gem_name}-%{version}.gemspec
%{gem_dir}/gems/%{gem_name}-%{version}/

%changelog
* Mon Jun 30 2014 Eric Timmerman <eric.timmerman@puppetlabs.com> - 1.0.0-2
- Fixes for el7, beggining to adhere to fedora guidelines

* Thu Jul 25 2013 Melissa Stone <melissa@puppetlabs.com> - 1.0.0-1
- Initial packaging for FOSS
